Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaParser.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaParser.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaParser.java	(revision 12)
@@ -7003,63 +7028,63 @@
     public static final BitSet FOLLOW_T_CTRL_in_namedAction1446 = new BitSet(new long[]{0x0008000000000000L});
     public static final BitSet FOLLOW_T_OBS_in_namedAction1451 = new BitSet(new long[]{0x0008000000000000L});
     public static final BitSet FOLLOW_T_IDENTIFIER_in_namedAction1463 = new BitSet(new long[]{0x0000010000000000L,0x0000000000000008L});
-    public static final BitSet FOLLOW_T_LPAREN_in_namedAction1471 = new BitSet(new long[]{0x0008000000000000L});
+    public static final BitSet FOLLOW_T_LPAREN_in_namedAction1471 = new BitSet(new long[]{0x0008000000000000L,0x0000000080000000L});
     public static final BitSet FOLLOW_methodParameterList_in_namedAction1473 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
-    public static final BitSet FOLLOW_T_RPAREN_in_namedAction1477 = new BitSet(new long[]{0x0000010000000000L});
-    public static final BitSet FOLLOW_T_EQUAL_in_namedAction1484 = new BitSet(new long[]{0x0000000000000000L,0x0002000008000000L});
-    public static final BitSet FOLLOW_T_VAR_in_namedAction1490 = new BitSet(new long[]{0x0008000000000000L});
-    public static final BitSet FOLLOW_localActionVars_in_namedAction1492 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
-    public static final BitSet FOLLOW_discreteActionBody_in_namedAction1503 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_T_IDENTIFIER_in_localActionVars1535 = new BitSet(new long[]{0x0000000000100000L});
-    public static final BitSet FOLLOW_T_COLON_in_localActionVars1537 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
-    public static final BitSet FOLLOW_complexType_in_localActionVars1541 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_T_SEMICOLON_in_localActionVars1550 = new BitSet(new long[]{0x0008000000000000L});
-    public static final BitSet FOLLOW_T_IDENTIFIER_in_localActionVars1554 = new BitSet(new long[]{0x0000000000100000L});
-    public static final BitSet FOLLOW_T_COLON_in_localActionVars1556 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
-    public static final BitSet FOLLOW_complexType_in_localActionVars1560 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_discreteActionBody_in_anonymousAction1593 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_T_REQUIRES_in_discreteActionBody1624 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
-    public static final BitSet FOLLOW_expression_in_discreteActionBody1628 = new BitSet(new long[]{0x0000000000100000L});
-    public static final BitSet FOLLOW_T_COLON_in_discreteActionBody1630 = new BitSet(new long[]{0x2008000000008040L,0x0002002208000008L});
-    public static final BitSet FOLLOW_actionBody_in_discreteActionBody1637 = new BitSet(new long[]{0x0000008000000000L});
-    public static final BitSet FOLLOW_T_END_in_discreteActionBody1642 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_actionBlockParallel_in_actionBlock1685 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
-    public static final BitSet FOLLOW_T_PRIO_in_actionBlock1689 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
-    public static final BitSet FOLLOW_actionBlockParallel_in_actionBlock1691 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
-    public static final BitSet FOLLOW_actionBlockSequential_in_actionBlockParallel1724 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
-    public static final BitSet FOLLOW_T_NONDET_in_actionBlockParallel1728 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
-    public static final BitSet FOLLOW_actionBlockSequential_in_actionBlockParallel1730 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
-    public static final BitSet FOLLOW_T_VAR_in_actionBlockSequential1764 = new BitSet(new long[]{0x0008000000000000L});
-    public static final BitSet FOLLOW_blockvarlist_in_actionBlockSequential1768 = new BitSet(new long[]{0x0000000000100000L,0x0010000000000000L});
-    public static final BitSet FOLLOW_116_in_actionBlockSequential1772 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
-    public static final BitSet FOLLOW_expression_in_actionBlockSequential1776 = new BitSet(new long[]{0x0000000000100000L});
-    public static final BitSet FOLLOW_T_COLON_in_actionBlockSequential1783 = new BitSet(new long[]{0x0008000000000000L,0x0000002008000008L});
-    public static final BitSet FOLLOW_actionBlockParen_in_actionBlockSequential1792 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_T_SEMICOLON_in_actionBlockSequential1796 = new BitSet(new long[]{0x0008000000000000L,0x0000002008000008L});
-    public static final BitSet FOLLOW_actionBlockParen_in_actionBlockSequential1798 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_T_LPAREN_in_actionBlockParen1822 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
-    public static final BitSet FOLLOW_actionBlock_in_actionBlockParen1824 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
-    public static final BitSet FOLLOW_T_RPAREN_in_actionBlockParen1827 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_anonymousOrNamedAction_in_actionBlockParen1832 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_anonymousAction_in_anonymousOrNamedAction1849 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_T_IDENTIFIER_in_anonymousOrNamedAction1858 = new BitSet(new long[]{0x0000600000000002L,0x0000000000000008L});
-    public static final BitSet FOLLOW_T_LPAREN_in_anonymousOrNamedAction1872 = new BitSet(new long[]{0x512C963244030080L,0x000048829000B298L});
-    public static final BitSet FOLLOW_methodCallParams_in_anonymousOrNamedAction1877 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
-    public static final BitSet FOLLOW_T_RPAREN_in_anonymousOrNamedAction1879 = new BitSet(new long[]{0x0000600000000002L});
-    public static final BitSet FOLLOW_set_in_anonymousOrNamedAction1897 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
-    public static final BitSet FOLLOW_T_LPAREN_in_anonymousOrNamedAction1903 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
-    public static final BitSet FOLLOW_expression_in_anonymousOrNamedAction1907 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
-    public static final BitSet FOLLOW_T_RPAREN_in_anonymousOrNamedAction1909 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_T_SKIP_in_anonymousOrNamedAction1920 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_blockvar_in_blockvarlist1936 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_T_SEMICOLON_in_blockvarlist1941 = new BitSet(new long[]{0x0008000000000000L});
-    public static final BitSet FOLLOW_blockvar_in_blockvarlist1943 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
-    public static final BitSet FOLLOW_T_IDENTIFIER_in_blockvar1963 = new BitSet(new long[]{0x0000000000100000L});
-    public static final BitSet FOLLOW_T_COLON_in_blockvar1966 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
-    public static final BitSet FOLLOW_complexType_in_blockvar1970 = new BitSet(new long[]{0x0000000000000002L});
-    public static final BitSet FOLLOW_actionBodyParallel_in_actionBody2005 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
-    public static final BitSet FOLLOW_T_PRIO_in_actionBody2009 = new BitSet(new long[]{0x2008000000008040L,0x0002002208000008L});
-    public static final BitSet FOLLOW_actionBodyParallel_in_actionBody2011 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_T_RPAREN_in_namedAction1478 = new BitSet(new long[]{0x0000010000000000L});
+    public static final BitSet FOLLOW_T_EQUAL_in_namedAction1485 = new BitSet(new long[]{0x0000000000000000L,0x0002000008000000L});
+    public static final BitSet FOLLOW_T_VAR_in_namedAction1491 = new BitSet(new long[]{0x0008000000000000L});
+    public static final BitSet FOLLOW_localActionVars_in_namedAction1493 = new BitSet(new long[]{0x0000000000000000L,0x0000000008000000L});
+    public static final BitSet FOLLOW_discreteActionBody_in_namedAction1504 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_T_IDENTIFIER_in_localActionVars1536 = new BitSet(new long[]{0x0000000000100000L});
+    public static final BitSet FOLLOW_T_COLON_in_localActionVars1538 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
+    public static final BitSet FOLLOW_complexType_in_localActionVars1542 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_T_SEMICOLON_in_localActionVars1551 = new BitSet(new long[]{0x0008000000000000L});
+    public static final BitSet FOLLOW_T_IDENTIFIER_in_localActionVars1555 = new BitSet(new long[]{0x0000000000100000L});
+    public static final BitSet FOLLOW_T_COLON_in_localActionVars1557 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
+    public static final BitSet FOLLOW_complexType_in_localActionVars1561 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_discreteActionBody_in_anonymousAction1594 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_T_REQUIRES_in_discreteActionBody1625 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
+    public static final BitSet FOLLOW_expression_in_discreteActionBody1629 = new BitSet(new long[]{0x0000000000100000L});
+    public static final BitSet FOLLOW_T_COLON_in_discreteActionBody1631 = new BitSet(new long[]{0x2008000000008040L,0x0002002208000008L});
+    public static final BitSet FOLLOW_actionBody_in_discreteActionBody1638 = new BitSet(new long[]{0x0000008000000000L});
+    public static final BitSet FOLLOW_T_END_in_discreteActionBody1643 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_actionBlockParallel_in_actionBlock1686 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
+    public static final BitSet FOLLOW_T_PRIO_in_actionBlock1690 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
+    public static final BitSet FOLLOW_actionBlockParallel_in_actionBlock1692 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
+    public static final BitSet FOLLOW_actionBlockSequential_in_actionBlockParallel1725 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
+    public static final BitSet FOLLOW_T_NONDET_in_actionBlockParallel1729 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
+    public static final BitSet FOLLOW_actionBlockSequential_in_actionBlockParallel1731 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
+    public static final BitSet FOLLOW_T_VAR_in_actionBlockSequential1765 = new BitSet(new long[]{0x0008000000000000L});
+    public static final BitSet FOLLOW_blockvarlist_in_actionBlockSequential1769 = new BitSet(new long[]{0x0000000000100000L,0x0010000000000000L});
+    public static final BitSet FOLLOW_116_in_actionBlockSequential1773 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
+    public static final BitSet FOLLOW_expression_in_actionBlockSequential1777 = new BitSet(new long[]{0x0000000000100000L});
+    public static final BitSet FOLLOW_T_COLON_in_actionBlockSequential1784 = new BitSet(new long[]{0x0008000000000000L,0x0000002008000008L});
+    public static final BitSet FOLLOW_actionBlockParen_in_actionBlockSequential1793 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_T_SEMICOLON_in_actionBlockSequential1797 = new BitSet(new long[]{0x0008000000000000L,0x0000002008000008L});
+    public static final BitSet FOLLOW_actionBlockParen_in_actionBlockSequential1799 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_T_LPAREN_in_actionBlockParen1823 = new BitSet(new long[]{0x0008000000000000L,0x0002002008000008L});
+    public static final BitSet FOLLOW_actionBlock_in_actionBlockParen1825 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
+    public static final BitSet FOLLOW_T_RPAREN_in_actionBlockParen1828 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_anonymousOrNamedAction_in_actionBlockParen1833 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_anonymousAction_in_anonymousOrNamedAction1850 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_T_IDENTIFIER_in_anonymousOrNamedAction1859 = new BitSet(new long[]{0x0000600000000002L,0x0000000000000008L});
+    public static final BitSet FOLLOW_T_LPAREN_in_anonymousOrNamedAction1873 = new BitSet(new long[]{0x512C963244030080L,0x000048829000B298L});
+    public static final BitSet FOLLOW_methodCallParams_in_anonymousOrNamedAction1878 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
+    public static final BitSet FOLLOW_T_RPAREN_in_anonymousOrNamedAction1880 = new BitSet(new long[]{0x0000600000000002L});
+    public static final BitSet FOLLOW_set_in_anonymousOrNamedAction1898 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
+    public static final BitSet FOLLOW_T_LPAREN_in_anonymousOrNamedAction1904 = new BitSet(new long[]{0x512C963244030080L,0x000048821000B298L});
+    public static final BitSet FOLLOW_expression_in_anonymousOrNamedAction1908 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
+    public static final BitSet FOLLOW_T_RPAREN_in_anonymousOrNamedAction1910 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_T_SKIP_in_anonymousOrNamedAction1921 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_blockvar_in_blockvarlist1937 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_T_SEMICOLON_in_blockvarlist1942 = new BitSet(new long[]{0x0008000000000000L});
+    public static final BitSet FOLLOW_blockvar_in_blockvarlist1944 = new BitSet(new long[]{0x0000000000000002L,0x0000000400000000L});
+    public static final BitSet FOLLOW_T_IDENTIFIER_in_blockvar1964 = new BitSet(new long[]{0x0000000000100000L});
+    public static final BitSet FOLLOW_T_COLON_in_blockvar1967 = new BitSet(new long[]{0x04080800000A4000L,0x000000000000003CL});
+    public static final BitSet FOLLOW_complexType_in_blockvar1971 = new BitSet(new long[]{0x0000000000000002L});
+    public static final BitSet FOLLOW_actionBodyParallel_in_actionBody2006 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
+    public static final BitSet FOLLOW_T_PRIO_in_actionBody2010 = new BitSet(new long[]{0x2008000000008040L,0x0002002208000008L});
+    public static final BitSet FOLLOW_actionBodyParallel_in_actionBody2012 = new BitSet(new long[]{0x0000000000000002L,0x0000000001000000L});
     public static final BitSet FOLLOW_actionBodySequential_in_actionBodyParallel2046 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
     public static final BitSet FOLLOW_T_NONDET_in_actionBodyParallel2052 = new BitSet(new long[]{0x2008000000008040L,0x0002002208000008L});
     public static final BitSet FOLLOW_actionBodySequential_in_actionBodyParallel2056 = new BitSet(new long[]{0x0000000000000002L,0x0000000000004000L});
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCompleteAstTraversalVisitor.java	(revision 12)
@@ -88,6 +88,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
@@ -365,6 +366,7 @@
 	@Override
 	public void visit(TypeExpression typeExpression)
 	{
+		VisitSub(typeExpression.referredType(), typeExpression);
 		VisitSub(typeExpression.type(), typeExpression);
 	}
 
@@ -503,6 +505,11 @@
 	}
 
 	@Override
+	public void visit(MetaType metaType) {
+		VisitSub(metaType.Type(), metaType);
+	}
+
+	@Override
 	public void visit(EnumType enumType)
 	{
 		for (final Identifier sym: enumType.listOfEnumSymbols())
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaDeepCloneVisitor.java	(revision 12)
@@ -223,11 +223,13 @@
 
 	private void UpdateScope(IScope aScope)
 	{
-		if (aScope.GetParentScope() != null && !mapping.containsKey(aScope.GetParentScope()))
-			throw new ArgumentException();
-		else if (aScope.GetParentScope() != null)
+		// this requires parents to be added before their children
+		if (aScope.GetParentScope() != null)
 		{
-			aScope.SetParentScope((IScope)mapping.get(aScope.GetParentScope()));
+			if(!mapping.containsKey(aScope.GetParentScope()))
+				throw new ArgumentException();
+			else
+				aScope.SetParentScope((IScope)mapping.get(aScope.GetParentScope()));
 		}
 	}
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java	(revision 12)
@@ -80,6 +80,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
@@ -206,5 +207,7 @@
 	@Override
 	public void visit(NullType nullType)                         {throw new UnsupportedOperationException();}
 	@Override
+	public void visit(MetaType metaType)                         {throw new UnsupportedOperationException();}
+	@Override
 	public void visit(MainModule mainModule)                     {throw new UnsupportedOperationException();}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaObjectInstantiationVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaObjectInstantiationVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaObjectInstantiationVisitor.java	(revision 12)
@@ -76,6 +76,7 @@
 		m_toReplace.putSafe(attributeIdentifier, newAttribute);
 
 		newAttribute.SetInitializer(newAttribute.initializer().Clone());
+		m_toReplace.putSafe(attributeIdentifier.initializer(), newAttribute.initializer());
 		final OoaDeepCloneVisitor cloner = new OoaDeepCloneVisitor(m_toReplace, self);
 		newAttribute.initializer().Accept(cloner);
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java	(revision 12)
@@ -78,6 +78,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
@@ -408,7 +409,13 @@
 		output.Append("nil");
 	}
 
+	@Override
+	public void visit(MetaType metaType) {
+		output.Append("type of ");
+		super.visit(metaType);
+	}
 
+
 	@Override
 	public void visit(AttributeIdentifier attributeIdentifier)
 	{
@@ -651,7 +658,7 @@
 	@Override
 	public void visit(TypeExpression typeExpression)
 	{
-		PrintSubElementOrNull(typeExpression.type());
+		PrintSubElementOrNull(typeExpression.referredType());
 	}
 
 	@Override
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaStaticListCastVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaStaticListCastVisitor.java	(nonexistent)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaStaticListCastVisitor.java	(revision 12)
@@ -0,0 +1,63 @@
+package org.momut.ooas.visitors;
+
+import java.util.ArrayList;
+
+import org.momut.ooas.ast.expressions.Expression;
+import org.momut.ooas.ast.expressions.ExpressionKind;
+import org.momut.ooas.ast.expressions.ListConstructor;
+import org.momut.ooas.ast.expressions.UnaryOperator;
+import org.momut.ooas.ast.types.ListType;
+import org.momut.ooas.ast.types.Type;
+import org.momut.ooas.ast.types.TypeKind;
+
+public class OoaStaticListCastVisitor extends OoaExpressionVisitor
+{
+	private final Type m_leafType;
+	private ListType m_listType;
+
+	public OoaStaticListCastVisitor(ListType targetType)
+	{
+		m_leafType = leafType(targetType);
+		m_listType = targetType;
+	}
+
+	@Override
+	public void visit(ListConstructor listConstructor)
+	{
+		final ArrayList<Expression> casts = new ArrayList<>();
+		for (final Expression elems: listConstructor.elements()) {
+			if(elems.kind() == ExpressionKind.ListConstr){
+				final ListType parent = m_listType;
+				m_listType = (ListType) m_listType.innerType();
+				VisitSub(elems, listConstructor);
+				m_listType = parent;
+			}
+			else
+			{
+				if(elems.kind() == ExpressionKind.Cast)
+					elems.SetType(m_leafType);
+				else
+				{
+					final Expression cast = new UnaryOperator(ExpressionKind.Cast, elems, elems.line(), elems.pos());
+					cast.SetType(m_leafType);
+					casts.add(cast);
+				}
+			}
+		}
+		if(!casts.isEmpty())
+			listConstructor.SetElements(casts);
+
+		listConstructor.SetType(m_listType);
+	}
+
+	private Type leafType(Type type)
+	{
+		Type result = type;
+
+		while(result.kind() == TypeKind.ListType)
+			result = ((ListType)result).innerType();
+
+		return result;
+	}
+
+}
